﻿Type=Activity
Version=2.71
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: False
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Dim FilterCons As Boolean
	Dim FilterNums As Boolean 
	Dim FilterTypes As Boolean
	Dim FilterDate As Boolean 
	Dim FilterDurs As Boolean 
	Dim TypeSelected As List 
	Dim FromFilter As Long 
	Dim UntilFilter As Long 
	Dim FromDur As Long 
	Dim UntilDur As Long 
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	Dim CmdCons,CmdNums,CmdType,CmdDate,CmdDurs As Button 
End Sub

Sub Activity_Create(FirstTime As Boolean)
	'Do not forget to load the layout file created with the visual designer. For example:
	Activity.LoadLayout("FilterReport")
	If FilterCons=True Then
		CmdCons.Text="Selected Contacts"
	Else
		CmdCons.Text="All Contacts"
	End If
	If FilterNums=True Then
		CmdNums.Text="Selected Numbers"
	Else
		CmdNums.Text="All Numbers"
	End If
	If FilterTypes=True Then
		CmdType.Text="Selected Types"
	Else
		CmdType.Text="All Types"
	End If		
	If FilterDate=True Then
		CmdDate.Text="Selected Dates"
	Else
		CmdDate.Text="All Dates"
	End If
	If FilterDurs=True Then
		CmdDurs.Text="Selected Durations"
	Else
		CmdDurs.Text="All Durations"
	End If
	
	FromFilter=0
	UntilFilter=DateTime.Add(DateTime.Now,1,0,0)
End Sub

Sub Activity_Resume
	If FilterCons=True Then
		CmdCons.Text="Selected Contacts"
	Else
		CmdCons.Text="All Contacts"
	End If
	If FilterNums=True Then
		CmdNums.Text="Selected Numbers"
	Else
		CmdNums.Text="All Numbers"
	End If
	If FilterTypes=True Then
		CmdType.Text="Selected Types"
	Else
		CmdType.Text="All Types"
	End If
	If FilterDate=True Then
		CmdDate.Text="Selected Dates"
	Else
		CmdDate.Text="All Dates"
	End If
	If FilterDurs=True Then
		CmdDurs.Text="Selected Durations"
	Else
		CmdDurs.Text="All Durations"
	End If
End Sub

Sub Activity_Pause (UserClosed As Boolean)
	Activity.Finish 
End Sub

Sub CmdCons_Click
	StartActivity("GetContact")
End Sub
Sub CmdConsCancel_Click
	FilterCons=False
	CmdCons.Text="All Contacts"
End Sub
Sub CmdFinish_Click
Dim result As Int  	
	If FilterCons=False AND FilterNums=False AND FilterDate=False AND FilterTypes=False AND FilterDurs =False Then
		result=Msgbox2 ( "You did not filter any field","Call log Report Generator","OK","","Back",Null )
		If result=DialogResponse.POSITIVE Then
			ReportDetails.NewReportGlobal=True
			StartActivity("ReportDetails")
		End If
	Else
		Reset_Sort
		ReportDetails.NewReportGlobal=True
		StartActivity("ReportDetails")
	End If
End Sub
Sub CmdNums_Click
	StartActivity("GetNumber")
End Sub
Sub CmdNumsCancel_Click
	FilterNums=False
	CmdNums.Text="All Numbers"	
End Sub
Sub CmdType_Click
	Dim TypeSList As List 
	Dim result As List 
	TypeSList.Initialize 
	TypeSelected.Initialize 
	TypeSList.Add("Incoming")
	TypeSList.Add("Missed")
	TypeSList.Add("Outgoing")

	result = InputMultiList(TypeSList, "Select Call Types") 
	For i = 0 To result.Size - 1
	 	TypeSelected.Add( TypeSList.get(result.get(i)) ) 
	Next
	If TypeSelected.Size=0 Then 
		FilterTypes=False
		CmdType.Text="All Types"
	Else
		FilterTypes=True 
		CmdType.Text="Selected Types"
	End If
End Sub
Sub CmdTypeCancel_Click
	FilterTypes=False
	CmdType.Text="All Types"
End Sub

Sub CmdDate_Click
	Dim FromDate As DateDialog
	Dim UntilDate As DateDialog
	Dim FromSelected As Boolean 
	Dim UntilSelected As Boolean 
	
	If FromFilter=0 Then
		FromDate.Year = DateTime.GetYear(DateTime.Now)
		FromDate.Month = DateTime.GetMonth(DateTime.Now)
		FromDate.DayOfMonth = DateTime.GetDayOfMonth(DateTime.Now)
	Else
		FromDate.Year = DateTime.GetYear(FromFilter)
		FromDate.Month = DateTime.GetMonth(FromFilter)
		FromDate.DayOfMonth = DateTime.GetDayOfMonth(FromFilter)
	End If
	ret = FromDate.Show("Set the required date", "From", "OK", "Cancel" ,"", Null)
	If ret=-1 Then
		FromFilter =FromDate.DateTicks
		ToastMessageShow("Saved" & " : " & FromDate.DayOfMonth & "/" & FromDate.Month & "/" & FromDate.Year , False) 
		FromSelected=True
	End If
	
	If UntilFilter>DateTime.Add(DateTime.Now,0,10,0) Then 
		UntilDate.Year = DateTime.GetYear(DateTime.Now)
		UntilDate.Month = DateTime.GetMonth(DateTime.Now)
		UntilDate.DayOfMonth = DateTime.GetDayOfMonth(DateTime.Now)
	Else 
		UntilDate.Year = DateTime.GetYear(UntilFilter)
		UntilDate.Month = DateTime.GetMonth(UntilFilter)
		UntilDate.DayOfMonth = DateTime.GetDayOfMonth(UntilFilter)
	End If
	ret = UntilDate.Show("Set the required date", "Until", "OK", "Cancel" ,"", Null)
	If ret=-1 Then
		UntilFilter =UntilDate.DateTicks	
		ToastMessageShow("Saved" & " : " & UntilDate.DayOfMonth & "/" & UntilDate.Month & "/" & UntilDate.Year , False)
		UntilSelected=True
	End If
	If FromSelected=True AND UntilSelected=True Then
		FilterDate=True
		CmdDate.Text="Selected Dates"
	Else
		FilterDate=False
		CmdDate.Text="All Dates"	
	End If
End Sub
Sub CmdDateCancel_Click
	FilterDate=False
	CmdDate.Text="All Dates"
End Sub
Sub CmdDurs_Click
	Dim FromDurDialog As InputDialog 
	Dim UntilDurDialog As InputDialog 
	Dim P As Phone 
	Dim ResultFrom As Int 
	Dim ResultUntil As Int 
	
	FromDurDialog.Input =0
	FromDurDialog.InputType =FromDurDialog.INPUT_TYPE_NUMBERS 
	ResultFrom=FromDurDialog.Show("Minutes","Minimum","OK","Cancel", "",Null)
	If ResultFrom=DialogResponse.POSITIVE Then
		FromDur=FromDurDialog.Input 
	End If	
	UntilDurDialog.Input=0
	UntilDurDialog.InputType=UntilDurDialog.INPUT_TYPE_NUMBERS 
	ResultUntil=UntilDurDialog.Show("Minutes","Maximum","OK","Cancel", "",Null)
	If ResultUntil=DialogResponse.POSITIVE Then
		UntilDur=UntilDurDialog.Input
	End If
	FromDur=FromDur*60
	UntilDur=UntilDur*60
	
	If ResultFrom=DialogResponse.POSITIVE AND ResultUntil=DialogResponse.POSITIVE Then
		CmdDurs.Text="Selected Durations"
		FilterDurs =True
	Else
		FilterDurs=False
		CmdDurs.Text="All Durations"	
	End If
	P.HideKeyboard(Activity)
End Sub
Sub CmdDursCancel_Click
	FilterDurs=False
	CmdDurs.Text="All Durations"
End Sub

Sub CmdNext_Click
Dim result As Int  	
If FilterCons=False AND FilterNums=False AND FilterDate=False AND FilterTypes=False AND FilterDurs =False Then
	result=Msgbox2 ( "You did not filter any field","Call log Report Generator","OK","","Back",Null )
	If result=DialogResponse.POSITIVE Then
		StartActivity("SortReport")
	End If
Else
	Reset_Sort
	StartActivity("SortReport")
End If
End Sub
Sub Reset_Sort
SortReport.SortCons=False
SortReport.SortNums=False
SortReport.SortTypes=False
SortReport.SortDate=False 
SortReport.SortDurs=False
End Sub	