﻿Type=Activity
Version=2.71
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: False
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Dim FldsGlobal(5) As String
	Dim NumOfFldsGlobal As Int 
	Dim FilterStrGlobal As String 
	Dim SortStrGlobal As String 
	Dim ReportName As String 
	Dim NewReportGlobal As Boolean 
	Dim SqlStringGlobal As String 
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	Dim CmdGenerate,CmdDelete As Button
	Dim LblFilterStr,LblReportDate,LblNumOfFlds,LblFldsStr,LblSortStr As Label 
	Dim LblReportName As Label 
	Dim TableIndex As Table
End Sub

Sub Activity_Create(FirstTime As Boolean)
	'Do not forget to load the layout file created with the visual designer. For example:
	'Activity.LoadLayout("Layout1")
	Dim FldsStr As String 
	
	Activity.LoadLayout("ReportDetails")
	
	If Library.FromLibrary=True Then
		'ReportName=Library.ReportName
		LblReportName.Text =Library.ReportNameLib
		LblReportDate.Text=DateTime.Date(Library.ReportDate)
'		LblFilterStr.Text=Library.ReporotFilterStr.Replace(","," ")
'		LblFldsStr.Text=Library.ReportFldsStr.Replace(","," ") 
'		LblNumOfFlds.Text=Library.ReportNumOfFlds 
'		LblSortStr.Text=Library.ReportSortStr 
		Set_TableIndex(Library.ReportFldsStr,Library.ReporotFilterStr,Library.ReportSortStr)		
	Else If NewReportGlobal=True Then
		ReportName =Get_Temp_File_Name("My")
		LblReportName.Text =ReportName
		LblReportDate.Text=DateTime.Date(DateTime.Now)
		SqlStringGlobal=Build_String
		Reset_FldsGlobal
		Build_Flds
		FilterStrGlobal=""
		BulidFilterStr
		SortStrGlobal=""
		BuildSortStr
		FldsStr=FldsGlobal(0) & "," & FldsGlobal(1) & "," & FldsGlobal(2) & "," & FldsGlobal(3) & "," & FldsGlobal(4)
'		LblFilterStr.Text=FilterStrGlobal.Replace(","," ") 
'		LblFldsStr.Text=FldsStr.Replace(","," ")
'		LblNumOfFlds.Text=NumOfFldsGlobal 
'		LblSortStr.Text=SortStrGlobal 
		CmdDelete.Enabled=False
		Set_TableIndex(FldsStr,FilterStrGlobal,SortStrGlobal)
	Else If System.SystemReportGlobal=True Then
		SqlStringGlobal=System.SqlSystem 
		FldsGlobal(0)=System.FldsSystem(0) 
		FldsGlobal(1)=System.FldsSystem(1) 
		FldsGlobal(2)=System.FldsSystem(2) 
		FldsGlobal(3)=System.FldsSystem(3) 
		FldsGlobal(4)=System.FldsSystem(4) 
		NumOfFldsGlobal=System.NumOfFldsSystem 
		CmdDelete.Enabled=False
		ReportName =Get_Temp_File_Name(System.SystemReportName)
		LblReportName.Text =ReportName
		LblReportDate.Text=DateTime.Date(DateTime.Now)
	End If

End Sub
Sub Build_String() As String 

'start sql string
Dim SqlString As String 
Dim NameAndNumber As String
Dim nPos As Int
'Dim Name As String
Dim Number As String

SqlString="select * from CallLog "
If FilterReport.FilterCons=True Then
	SqlString=SqlString & " where Name in("
	For i = 0 To GetContact.SelectedList.Size - 1
		SqlString=SqlString & "'" & GetContact.SelectedList.Get(i) & "',"
	Next	
	SqlString=SqlString.SubString2( 0,SqlString.Length -1)
	SqlString=SqlString & ")"
End If

If FilterReport.FilterNums=True Then
	If FilterReport.FilterCons=True Then
		SqlString=SqlString & " or Number in("
	Else
		SqlString=SqlString & " where Number in("
	End If
	
	For i = 0 To GetNumber.SelectedList.Size - 1
		NameAndNumber = GetNumber.SelectedList.Get(i)
		nPos = NameAndNumber.IndexOf(CRLF)
		Number=NameAndNumber.SubString2(0, nPos)
		'Name  = NameAndNumber.SubString(nPos + 1)
		SqlString=SqlString & "'" & Number  & "',"
	Next	
	SqlString=SqlString.SubString2( 0,SqlString.Length -1)
	SqlString=SqlString & ")"
End If

If FilterReport.FilterTypes=True Then
	If FilterReport.FilterCons=True OR FilterReport.FilterNums=True Then
		SqlString=SqlString & " and Type in("
	Else
		SqlString=SqlString & " where Type in("
	End If
	
	For i = 0 To FilterReport.TypeSelected.Size - 1
		SqlString=SqlString & "'" & FilterReport.TypeSelected.Get(i) & "',"
	Next	
	SqlString=SqlString.SubString2( 0,SqlString.Length -1)
	SqlString=SqlString & ")"
End If

If FilterReport.FilterDate=True Then
	If FilterReport.FilterCons=True OR FilterReport.FilterNums=True OR FilterReport.FilterTypes=True Then
		SqlString=SqlString & " and Date between " & FilterReport.FromFilter & " and " & FilterReport.UntilFilter 
	Else
		SqlString=SqlString & " where Date between " & FilterReport.FromFilter & " and " & FilterReport.UntilFilter 
	End If
End If

If FilterReport.FilterDurs=True Then
	If FilterReport.FilterCons=True OR FilterReport.FilterNums=True OR FilterReport.FilterTypes=True OR FilterReport.FilterDate=True  Then
		SqlString=SqlString & " and Duration between " & FilterReport.FromDur & " and " & FilterReport.UntilDur 
	Else
		SqlString=SqlString & " where Duration between " & FilterReport.FromDur & " and " & FilterReport.UntilDur
	End If
End If
'sort
If SortReport.SortCons=True Then
	SqlString=SqlString & " order by Name " & SortReport.SortString 
End If

If SortReport.SortNums =True Then
	SqlString=SqlString & " order by Number " & SortReport.SortString 
End If

If SortReport.SortTypes =True Then
	SqlString=SqlString & " order by Type " & SortReport.SortString 
End If

If SortReport.SortDate =True Then
	SqlString=SqlString & " order by Date " & SortReport.SortString 
End If

If SortReport.SortDurs =True Then
	SqlString=SqlString & " order by Duration " & SortReport.SortString 
End If
Return SqlString
End Sub
Sub Set_TableIndex(FldsStr As String,FilterStr As String,SortStr As String) 
	'Dim FldsStr As String 
	Dim NameArray(4) As String 
	Dim NumberArray(4) As String 
	Dim TypeArray(4) As String 
	Dim DateArray(4) As String 
	Dim DurationArray(4) As String 
		
	TableIndex.Initialize( Me, "TableIndex", 4, Gravity.CENTER,False)
	TableIndex.AddToActivity(Activity, 0dip,  30%y, 100%x,180dip)
	TableIndex.SetHeader(Array As String("Column" ,"Display","Filter","Sort"))

	NameArray(0)="Name"
	If FldsStr.Contains("Name") Then
		NameArray(1)="Yes"
	End If
	If FilterStr.Contains("Name") Then
		NameArray(2)="Yes"
	End If
	If SortStr.Contains("Name") Then
		NameArray(3)="Yes"
	End If
	TableIndex.AddRow(NameArray)

	NumberArray(0)="Number"
	If FldsStr.Contains("Number") Then
		NumberArray(1)="Yes"
	End If
	If FilterStr.Contains("Number") Then
		NumberArray(2)="Yes"
	End If
	If SortStr.Contains("Number") Then
		NumberArray(3)="Yes"
	End If
	TableIndex.AddRow(NumberArray)
	
	TypeArray(0)="Type"
	If FldsStr.Contains("Type") Then
		TypeArray(1)="Yes"
	End If
	If FilterStr.Contains("Type") Then
		TypeArray(2)="Yes"
	End If
	If SortStr.Contains("Type") Then
		TypeArray(3)="Yes"
	End If
	TableIndex.AddRow(TypeArray)
		
	DateArray(0)="Date"
	If FldsStr.Contains("Date") Then
		DateArray(1)="Yes"
	End If
	If FilterStr.Contains("Date") Then
		DateArray(2)="Yes"
	End If
	If SortStr.Contains("Date") Then
		DateArray(3)="Yes"
	End If
	TableIndex.AddRow(DateArray)

	DurationArray(0)="Duration"
	If FldsStr.Contains("Duration") Then
		DurationArray(1)="Yes"
	End If
	If FilterStr.Contains("Duration") Then
		DurationArray(2)="Yes"
	End If
	If SortStr.Contains("Duration") Then
		DurationArray(3)="Yes"
	End If
	TableIndex.AddRow(DurationArray)
			
End Sub
Sub Reset_FldsGlobal
For i=0 To 4
	FldsGlobal(i)=""
Next 
End Sub
Sub CmdGenerate_Click
	
	StartActivity("ShowTable")
End Sub
Sub Activity_Resume
If Library.FromLibrary=False AND NewReportGlobal=False AND System.SystemReportGlobal=False Then
	LblReportName.Text =ReportName
	CmdDelete.Enabled=True
End If
End Sub

Sub Activity_Pause (UserClosed As Boolean)

'Activity.Finish 
End Sub
Sub BulidFilterStr
If FilterReport.FilterCons=True Then
	FilterStrGlobal="Name,"
End If
If FilterReport.FilterNums=True Then
	FilterStrGlobal=FilterStrGlobal & "Number,"
End If
If FilterReport.FilterTypes=True Then
	FilterStrGlobal=FilterStrGlobal & "Type,"
End If
If FilterReport.FilterDate=True Then
	FilterStrGlobal=FilterStrGlobal & "Date,"
End If
If FilterReport.FilterDurs=True Then
	FilterStrGlobal=FilterStrGlobal & "Duration"
End If	
End Sub
Sub BuildSortStr
If SortReport.SortCons=True Then
	SortStrGlobal="Name"
End If
If SortReport.SortNums =True Then
	SortStrGlobal=SortStrGlobal & "Number"
End If
If SortReport.SortTypes =True Then
	SortStrGlobal=SortStrGlobal & "Type"
End If
If SortReport.SortDate =True Then
	SortStrGlobal=SortStrGlobal & "Date"
End If
If SortReport.SortDurs =True Then
	SortStrGlobal=SortStrGlobal & "Duration"
End If
End Sub
Sub Build_Flds

Dim Fld1 As String 
Dim Fld2 As String 
Dim Fld3 As String 
Dim Fld4 As String 
Dim Fld5 As String 
Dim NumOfFields As Int 
'SqlString="select " 
If BuildReport.ShowContact=True Then
	NumOfFields=NumOfFields+1
	Fld1="Name"
End If

If BuildReport.ShowNumber =True Then
	NumOfFields=NumOfFields+1
	Select Case NumOfFields
	Case 1
		Fld1="Number"
	Case 2
		Fld2="Number" 
	End Select 
End If

If BuildReport.ShowType =True Then
	NumOfFields=NumOfFields+1
	Select Case NumOfFields
	Case 1
		Fld1="Type"
	Case 2
		Fld2="Type" 
	Case 3
		Fld3="Type"
	End Select 
End If

If BuildReport.ShowDate =True Then
	NumOfFields=NumOfFields+1
	Select Case NumOfFields
	Case 1
		Fld1="Date"
	Case 2
		Fld2="Date" 
	Case 3
		Fld3="Date"
	Case 4
		Fld4="Date"
	End Select 
End If

If BuildReport.ShowDuration =True Then
	NumOfFields=NumOfFields+1
	Select Case NumOfFields
	Case 1
		Fld1="Duration"
	Case 2
		Fld2="Duration" 
	Case 3
		Fld3="Duration"
	Case 4
		Fld4="Duration"
	Case 5
		Fld5="Duration"
	End Select 
End If

NumOfFldsGlobal=NumOfFields 
FldsGlobal=Array As String(Fld1,Fld2,Fld3,Fld4,Fld5)

End Sub

Sub Get_Temp_File_Name(Name As String) As String 
Dim FileName As String 
Dim Month As String 
Dim Day As String 
Dim Hour As String 
Dim Minute As String 

Month =DateTime.GetMonth(DateTime.now)
If Month.Length=1 Then 
	Month="0" & Month
End If
Day=DateTime.GetDayOfMonth(DateTime.now)
If Day.Length=1 Then
	Day="0" & Day
End If
Hour =DateTime.GetHour(DateTime.now) 
If Hour.Length=1 Then 
	Hour="0" & Hour
End If
Minute=DateTime.GetMinute(DateTime.now)
If Minute.Length=1 Then 
	Minute="0" & Minute
End If

FileName = Name & Day & Month & Hour & Minute 
Return FileName
End Sub

Sub CmdDelete_Click
Dim path1,root As String

root=File.DirRootExternal
path1 = root & "/CallLogRG/Exports"
File.Delete(path1,LblReportName.Text & ".csv")
ToastMessageShow("Deleted",False)
Activity.Finish 
End Sub